"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Dependencies(ProtocolElement):
    """
    Represents contract of all dependencies for a service
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "apis",
        "datastores",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import system as system_0_1_0

        return {
            "apis": system_0_1_0.API,
            "datastores": system_0_1_0.DataStore,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import system as system_0_1_0

        return {
            "org.gel.models.system.avro.API": system_0_1_0.API,
            "org.gel.models.system.avro.DataStore": system_0_1_0.DataStore,
            "org.gel.models.system.avro.Dependencies": system_0_1_0.Dependencies,
        }

    __slots__ = [
        "apis",
        "datastores",
    ]

    def __init__(
        self,
        apis,
        datastores,
        validate=None,
        **kwargs
    ):
        """Initialise the system_0_1_0.Dependencies model.

        :param apis:
        :type apis: list[API]
        :param datastores:
        :type datastores: list[DataStore]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "0.1.0"
